<template>
  <div style="margin: 3rem">
     <header style="margin:10rem 6rem 3rem 6rem">
        <ReturnButton :isValidate="true" :offsetArrow="20" :spanTitle="3" title="Ir a Materiales" v-on:clickEvent="viewListReview" style="margin-bottom:2.5rem"></ReturnButton>
         <el-row :gutter="20">
          <!-- FILTROS DE BUSQUEDA --> 
            <el-col :span="18" class="text-end">
              <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
            </el-col>
            <el-col :span="6">
              <app-search-filter v-model="textSearch"></app-search-filter>
            </el-col>  
        </el-row>
      </header>

      <!-- COMPONENTE TITULO -->
      <div style="margin:3rem 6rem 4rem">
        <Title :Title="'REVISION DE '+ matType + ' - '+typeMaterialR.toUpperCase()"> </Title>
      </div>

      <!-- CUADRADITOS DE INFORMACION DEL ESTADO DE LOS PEDIDOS -->
      <div style="margin:3rem 6rem">
        <DescriptionStateOrders TextSquareGray="Sin Revisar" TextSquarePurple="Incompleto" TextSquareGreen="Aprobado y Al Aire" :TextSquareBlue="'Aprobado, pero no emitido'" :TextSquareRed="''"  :TextSquareOrange="'Aprobado y Emitido'" :colBoxes="6"> </DescriptionStateOrders>
      </div>

      <el-main style="margin:3rem 5rem">
        <el-row>
          <el-col 
            v-for="(material, index) in materials.slice(0,30)"
            :key="index"
            :span="18" :offset="3"
            style="margin-bottom: 4rem">

            <app-card-review 
              :showRate="true" :itemPrincipal="material" :shadowBox="(material.typeOfContent == 'Novelas' || material.typeOfContent == 'TELENOVELA' || material.typeOfContent == 'TELEVISA - TELENOVELAS')?'pink-shadow':((material.typeOfContent == 'TELEVISA - SERIES' || material.typeOfContent == 'SERIE' || material.typeOfContent == 'Series')?'skyblue-shadow':'yellow-shadow')" :imgStyle="'icon-card'"
              :detailsData="{
                0:{subtitle: 'Código de Material', content: material.codMaterial},
                1:{subtitle: 'Proveedor', content: material.providerName},
                2:{subtitle: 'Cod. Proveedor', content: material.providerCode},
                3:{subtitle: 'Cod. Contrato', content: material.contractCode},
                
              }"
              :detailsData2="{
                0:{subtitle: 'Temporada', content: (material.numChapters.map(i => i.season)).join(' - ')},
                1:{subtitle: 'Género', content: (material.reviewObj)?(material.reviewObj.genre2)?(material.reviewObj.genre1)?material.reviewObj.genre1+ ' / ' + material.reviewObj.genre2:material.reviewObj.genre2:material.reviewObj.genre1:''},
                2:{subtitle: 'Clasificación', content: (material.reviewObj)?material.reviewObj.classification:''},
                3:{subtitle: 'Actores', content: material.reviewObj && material.reviewObj.artisticInfo ? material.reviewObj.artisticInfo[0].mainActors.join(', ') : '' },
              }"
              :btnGroup="{
                0:{validationBtnShow: material.reviewStatus === 'withoutChecking', btnClass: 'b-grey t-grey', btnTextAction: 'SIN REVISAR', editVal: 'selectedMaterial', newVal: 'revNovel'},  
                1:{validationBtnShow: material.reviewStatus === 'approved2', btnClass: 'b-blue t-blue', btnTextAction: 'NO EMITIDO', editVal: 'selectedMaterial', newVal: 'revNovelDoc'},
                2:{validationBtnShow: material.reviewStatus === 'live', btnClass: 'b-green t-green', btnTextAction: 'AL AIRE', editVal: 'selectedMaterial', newVal: 'revNovelDoc'},
                3:{validationBtnShow: material.reviewStatus === 'transmitted', btnClass: 'b-orange t-orange', btnTextAction: 'EMITIDO', editVal: 'selectedMaterial', newVal: 'revNovelDoc'},
                4: {validationBtnShow: material.reviewStatus === 'incompleteStyle', btnClass: 'b-purple t-purple', btnTextAction: 'INCOMPLETO', editVal: 'selectedMaterial', newVal: 'revNovelDoc'}
              }" /> 
          </el-col>
        </el-row>
      </el-main>
    <!-- </div> -->
  </div>
</template>

<script>
// @ is an alias to /src
import router from 'vue-router'
import ReturnButton from '@/components/ReturnButton.vue'
import CardReview from '@/components/cardReview'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import Title from '@/components/Title.vue'  
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue' 
import { modifyText } from '../../../utils/modifyText.js'
import { HTTP} from '../../../main.js'


export default {
  components: {
    ReturnButton,
    'app-card-review': CardReview,
    'app-search-filter': SearchFilter,
    'app-select': Select,
     Title,
     DescriptionStateOrders
  },
  data () {
    return {
      // mType: '',
      // canned: false,
      returnButtonModal: false,
      score: 4.8,
      filterSelect: '',
      textSearch: '',
      allFilters: [
        {value: 'providerCode', label: 'Código Proveedor'},
        {value: 'codMaterial', label: 'Código de Material'}

      ],
      // typeMaterial: '',
      typeMaterialR: localStorage.getItem('typeMaterialR'),
      // typeMaterialOracle: localStorage.getItem('typeMaterialOracle'),
      enlatado: localStorage.getItem('enlatado'),
      allMaterials: [],
      confirmedStatus: '',
      allMateriales: [],
      afiliado: '',
      afMaterials: [],
      afMat : [],
      matType: localStorage.getItem('classification'),
      // novelsStore: JSON.parse(this.$localStorage.get("allNovels")),
    }
  },
   created () {
    // this.getContracts()
    // 
    // 
    this.afiliado = JSON.parse(this.$localStorage.get('afiliado'))
    if(!this.afiliado){
      this.getMaterials()
    } else{
      console.log(this.typeMaterialR, 'this.typeMaterialR')
      if(this.typeMaterialR == 'Novelas') {
        this.getMaterialAff('TELEVISA - TELENOVELAS', 'afMat')
        this.getMaterialsDeAfiliado('Novelas', 'afMaterials')
      } else if(this.typeMaterialR == 'Series') {
        this.getMaterialAff('TELEVISA - SERIES', 'afMat')
        this.getMaterialsDeAfiliado('Series', 'afMaterials')
      } else if(this.typeMaterialR == 'Dibujos'){
        this.getMaterialsDeAfiliado('Dibujos', 'afMaterials')
      }
    }
    // if(this.afiliado == 'true'){
    //   if(this.typeMaterialR == 'Novelas'){
    //     this.getMaterialsDeAfiliado('TELEVISA - TELENOVELAS', 'afMaterials')
    //     this.getMaterialsDeAfiliado('Novelas', 'afMat')
    //   } else if(this.typeMaterialR == 'Series'){
    //     this.getMaterialsDeAfiliado('TELEVISA - SERIES', 'afMaterials')
    //     this.getMaterialsDeAfiliado('Series', 'afMat')
    //   }
    // } else{
    //   this.getMaterials()
    // }
    
  },
  computed: {
    materials () {
      // var boolValue =  (/true/i).test(this.enlatado)
      // console.log(this.allMateriales, 'allMateriales')
        // let allMovies = this.allMateriales.filter(
        //   m =>  m.canned == boolValue 
        // ) 
      let movies
      if(this.afiliado){
        movies = this.afMaterials.concat(this.afMat)
      } else {
        movies = this.allMateriales
      }

      if (this.filterSelect == '' && this.textSearch) {
        movies = movies.filter(
          m => modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) > -1) ||
                modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
                modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1 
      }
      else if (this.filterSelect && this.textSearch) {
        let total = []
        if (this.afiliado) {
           total = this.afMaterials.concat(this.afMat)    
        }
        else {
         total = this.allMateriales
        }
        console.log(total, 'total')

        movies = total.filter(
          m => modifyText(m[this.filterSelect]).indexOf(modifyText(this.textSearch)) !== -1)
      }
      return movies
    }
  },
  methods: {
    orderDataByGeminisCode (array) {
      array.sort(function (a, b) {
        if ( Number(a.geminisCode) >  Number(b.geminisCode) ) {
          return 1;
        }
        if ( Number(a.geminisCode) < Number(b.geminisCode )) {
          return -1;
        }
        return 0;
      });
      return array
    },
    getMaterials () {
      console.log(this.typeMaterialR, "this.typeMaterialR")
      this.allMateriales = this.orderDataByGeminisCode(this.$store.state[this.typeMaterialR]) 
    },
    getMaterialAff(material, value){
      HTTP.get('materials/materialType/'+material)
        .then(res => {
          let arrMaterial = res.data.materials
          this[value] = this.orderDataByGeminisCode(arrMaterial)
        })
        .catch(err => {
          console.log(err);
        });
    },
    getMaterialsDeAfiliado (material, arrTotal) {
      HTTP.get('materials/materialType/Televisa/typeOfContent/' + material + '/canned/true')
      /*revisar esta consulta */
      // HTTP.get('materials/materialType/Televisa/typeOfContent/' + material +'/canned/false')
      .then(res => {
        let arrOfMaterial = res.data.materials
        let materialsToShow = []
        arrOfMaterial.map(el => {
          /*comentando esta validacion para que muestre todos los materiales afiliados sean creados por in_grid o geminis */
          // if(el.providerName !== ''){
            materialsToShow.push(el)
          // }
        })
        this[arrTotal] = this.orderDataByGeminisCode(materialsToShow)
      })
      .catch(err => console.log(err))
    },
    viewListReview () {
      if(this.afiliado){
        this.$router.push({name: 'revAfiliadoTelevisa'})
      } else {
        this.$router.push({name: 'materialesEnlatados', params: { canned: true } })
      }
    }
  }
}
</script>

<style>
.pink-shadow{
  box-shadow: 5px 5px 10px #db3f5459 !important;
}
.skyblue-shadow{
  box-shadow: 5px 5px 10px #1fbcab61 !important;
}
.yellow-shadow{
  box-shadow: 5px 5px 10px #ffff0063 !important;
}
.border-blue { /* Para los botones */
  border: 1.5px solid var(--color-blue-darken)!important;
}
.text-blue {
 color: var(--color-blue-darken)!important;
}
</style>